/*
** rhttpr.h for rhttpr in ~flav
** 
** Made by flav astraud
** Login   <flav@epita.fr>
** 
** Started on  Wed Jan  5 13:00:41 2000 flav astraud
** Last update Fri Feb 18 04:40:14 2000 rflav
*/
#define DEF_EAGENT	"User-Agent:"
#define DEF_ECONN	"Connection: Keep-Alive"
#define DEF_EHOST	"Host:"
#define DEF_EACCEPT	"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*"
#define DEF_ECHARSET	"Accept-Charset: iso-8859-1,*,utf-8"
#define DEF_EREFERER	"Referer:"
#define DEF_ECONTENTY	"Content-type:"
#define DEF_ECONTENTL	"Content-length:"
#define DEF_EGET	"GET"
#define DEF_EPOST	"POST"
#define DEF_EHEAD	"HEAD"
#define DEF_EVERSION	"HTTP/1.0"
#define DEF_ECOOKIE	"Cookie:"
#define DEF_PORT	80
#define DEF_HOST	"www.epita.fr"
#define DEF_AGENT	"rhttpr/0.0"
#define DEF_PROXY_PORT	3128
#define METHOD_GET	0
#define METHOD_POST	1
#define METHOD_HEAD	2
#define R_DATE		"Date:"
#define R_SERVER	"Server:"
#define R_LAST_MOD	"Last-Modified:"
#define R_CON_LEN	"Content-Length:"
#define R_CON_TYP	"Content-Type:"
#define R_AUTH		"Proxy-Authorization:"
#define MIN_BUF_SIZE	1024
#define END_OF_LINE	'\n'
#define SEP_CAR		' '
#define SEP_R		'\r'
#define DPOINT		':'
#define EMPTY_STRING	""
#define NORMAL_URL_CHAR	"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"
#define END_OF_URL	0
#define DESTROY(ptr)	if (ptr) free(ptr)
#define BASE64_LENGTH(l)	(4 * (((l) + 2) / 3))
/*
**
*/
typedef struct	s_tab_fhead
{
  char		*field;
  void		(*f)();
}		t_tab_fhead;

typedef struct	s_tab_of_method
{
  int		method;
  void		(*f)();
}		t_tab_of_method;

typedef struct	s_list
{
  struct s_list	*next;
  char		*name;
  char		*val;
}		t_list;

typedef struct	s_rhttprq
{
  char		*proxy;
  int		proxy_port;
  char		*proxy_user;
  char		*proxy_passwd;
  char		*user_agent;
  char		*host;
  int		port;
  int		method;
  char		*referer;
  char		*cookie;
  char		*action;
  char		*data;
  int		data_len;
  char		*auth_string;
  char		*contentype;
}		t_httprq;

typedef struct	s_httprs
{
  char		*version;
  int		val_ret;
  char		*msg_ret;
  int		content_length;
  char		*content_type;
  char		*server;
  char		*date;
  char		*last_modif;
  char		*data;
  t_list	*fl;
  t_list	*cur;
}		t_httprs;
